/*******************************************************************************
 * Copyright (c) 2010 IGA Tosiki, NTT DATA BUSINESS BRAINS Corp.
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 *
 * Contributors:
 *    IGA Tosiki (NTT DATA BUSINESS BRAINS Corp.) - initial API and implementation
 *******************************************************************************/
/*
 * blanco Framework
 * Copyright (C) 2004-2010 IGA Tosiki
 * 
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 */
package blanco.plugin.service.actions;

import java.io.File;
import java.lang.reflect.InvocationTargetException;

import org.eclipse.core.resources.IFile;
import org.eclipse.core.resources.IFolder;
import org.eclipse.core.resources.IResource;
import org.eclipse.core.runtime.CoreException;
import org.eclipse.core.runtime.IProgressMonitor;
import org.eclipse.jface.dialogs.MessageDialog;
import org.eclipse.jface.operation.IRunnableWithProgress;
import org.eclipse.swt.widgets.Shell;
import org.eclipse.ui.PlatformUI;

import blanco.plugin.service.BlancoServicePlugin;
import blanco.plugin.service.BlancoServicePluginConstants;
import blanco.plugin.service.editors.BlancoServicePluginUtil;
import blanco.service.BlancoServiceConstants;
import blanco.service.resourcebundle.BlancoServiceResourceBundle;
import blanco.service.task.BlancoServiceProcessImpl;
import blanco.service.task.valueobject.BlancoServiceProcessInput;

public class BlancoServiceGenerateAction {
    private static final BlancoServiceResourceBundle fBundle = new BlancoServiceResourceBundle();

    /**
     * ソースコード生成処理を実行します。
     * 
     * @param ifile
     *            処理対象のファイル。
     * @param shell
     *            親のシェル。
     * @param workbenchMonitor
     *            ワークベンチモニタ。
     * @param metaDir
     *            メタディレクトリ。
     * @throws InvocationTargetException
     *             実行時の例外。
     * @throws InterruptedException
     *             割り込み例外。
     * @throws CoreException
     */
    public static final void processBlancoServiceSource(final IFile ifile,
            final Shell shell, IProgressMonitor workbenchMonitor,
            final String metaDir) throws InvocationTargetException,
            InterruptedException, CoreException {
        if (ifile.getProject().getFolder(metaDir).exists() == false) {
            MessageDialog.openWarning(shell, "ソースコード生成", "メタディレクトリ (" + metaDir
                    + ") が存在しません。処理を中断します。");
            return;
        }

        // Eclipse 3.3 対策: begin
        // workbenchMonitorを利用することを停止しました。
        // org.eclipse.swt.SWTException: Invalid thread access が発生してしまいます。
        // Eclipse 3.3 対策: end

        final BlancoServiceProcessInput input = new BlancoServiceProcessInput();

        // Eclipse プラグインの所定のルールに従って自動生成ソースコードの文字エンコーディングを決定。
        final String encoding = ifile.getProject().getDefaultCharset(true);
        input.setEncoding(encoding);

        try {
            // PlatformUI.getWorkbench().getProgressService()を有益と判断。
            PlatformUI.getWorkbench().getProgressService().busyCursorWhile(
                    new IRunnableWithProgress() {
                        public void run(final IProgressMonitor monitor)
                                throws InvocationTargetException,
                                InterruptedException {
                            try {
                                monitor.beginTask(
                                        BlancoServiceConstants.PRODUCT_NAME
                                                + "ソースコード生成", 10);

                                if (monitor.isCanceled()) {
                                    return;
                                }

                                monitor.subTask("ディレクトリ: テンポラリフォルダの調整。");

                                // テンポラリフォルダを一旦削除します。
                                BlancoServicePluginUtil
                                        .deleteFolder(
                                                ifile,
                                                monitor,
                                                "tmp"
                                                        + BlancoServiceConstants.TARGET_SUBDIRECTORY);
                                BlancoServicePluginUtil
                                        .createFolder(
                                                ifile,
                                                monitor,
                                                "tmp"
                                                        + BlancoServiceConstants.TARGET_SUBDIRECTORY);
                                final IFolder tempFolder = BlancoServicePluginUtil
                                        .findFolder(
                                                ifile,
                                                monitor,
                                                "tmp"
                                                        + BlancoServiceConstants.TARGET_SUBDIRECTORY);

                                // ドキュメント一覧のための中間ファイル用ディレクトリ。
                                final File blancoTempDirectoryDocListing = ifile
                                        .getProject().getFolder(
                                                "tmp/doclisting").getLocation()
                                        .toFile();
                                blancoTempDirectoryDocListing.mkdirs();

                                if (monitor.isCanceled()) {
                                    return;
                                }

                                monitor.subTask(fBundle
                                        .getMetafileDisplayname()
                                        + " (*.xls)を処理します");
                                monitor.worked(1);

                                final IFolder findFolder = BlancoServicePluginUtil
                                        .findFolder(ifile, monitor, metaDir);
                                findFolder.refreshLocal(
                                        IResource.DEPTH_INFINITE, monitor);

                                IFolder folderTargetDirectory = ifile
                                        .getProject().getFolder("blanco");
                                if (ifile.getProject().getFolder(metaDir)
                                        .exists() == false) {
                                    folderTargetDirectory.create(true, true,
                                            monitor);
                                }

                                monitor.subTask("フォルダ作成: " + "blanco"
                                        + "/mainフォルダ");
                                final IFolder folderTargetDirectoryWithMain = folderTargetDirectory
                                        .getFolder("main");
                                if (ifile.getProject().getFolder(metaDir)
                                        .exists() == false) {
                                    folderTargetDirectoryWithMain.create(true,
                                            true, monitor);
                                }

                                final File blancoTargetDirectory = folderTargetDirectory
                                        .getLocation().toFile();

                                input.setMetadir(findFolder.getLocation()
                                        .toFile().getAbsolutePath());
                                input.setTmpdir(tempFolder.getLocation()
                                        .toFile().getAbsolutePath());
                                input.setTargetdir(blancoTargetDirectory
                                        .getAbsolutePath());

                                final BlancoServiceProcessImpl impl = new BlancoServiceProcessImpl() {
                                    public boolean progress(
                                            final String argProgressMessage) {
                                        if (monitor.isCanceled()) {
                                            // 処理中断します。
                                            return true;
                                        }
                                        monitor.subTask(argProgressMessage);
                                        return false;
                                    }
                                };
                                impl.execute(input);

                                if (monitor.isCanceled()) {
                                    return;
                                }

                                monitor.subTask("フォルダ更新: tmpフォルダ");
                                monitor.worked(1);

                                tempFolder.refreshLocal(
                                        IResource.DEPTH_INFINITE, monitor);

                                if (monitor.isCanceled()) {
                                    return;
                                }

                                folderTargetDirectory.refreshLocal(
                                        IResource.DEPTH_INFINITE, monitor);

                                if (BlancoServicePluginConstants.IS_DEBUG) {
                                    Thread.sleep(1000);
                                }
                            } catch (Exception e) {
                                // 最終防衛ライン
                                e.printStackTrace();
                                throw new InvocationTargetException(e, e
                                        .toString());
                            } catch (Error e) {
                                // 最終防衛ライン
                                e.printStackTrace();
                                throw new InvocationTargetException(e, e
                                        .toString());
                            } finally {
                                // 最後の最後では done扱いとします。
                                monitor.done();
                            }
                        }
                    });
        } catch (InvocationTargetException ex) {
            BlancoServicePlugin.log(ex);
            // 例外の中から本当の原因を取り出すことがポイントです。
            MessageDialog.openWarning(shell, "ソースコード生成",
                    "例外が発生しました。処理を中断します。\n" + ex.getCause().toString());
            ex.printStackTrace();
        } catch (InterruptedException ex) {
            BlancoServicePlugin.log(ex);
            MessageDialog.openWarning(shell, "ソースコード生成",
                    "割り込み中断例外が発生しました。処理を中断します。\n" + ex.toString());
            ex.printStackTrace();
        } catch (Exception ex) {
            BlancoServicePlugin.log(ex);
            MessageDialog.openWarning(shell, "ソースコード生成",
                    "予期せぬ例外が発生しました。処理を中断します。\n" + ex.toString());
            ex.printStackTrace();
        } catch (Error er) {
            BlancoServicePlugin.log(er);
            MessageDialog.openWarning(shell, "ソースコード生成",
                    "予期せぬエラーが発生しました。処理を中断します。\n" + er.toString());
            er.printStackTrace();
        }
    }
}